;; uniquify-test-project.el --- project for uniquify test files  -*- lexical-binding: t -*-

(require 'project)
(require 'uniquify-files)
(require 'file-complete-root-relative)

(cl-defstruct (uniquify-test-project)
  root
  )

(defun uniquify-test-project-try (dir)
  "For 'project-find-functions'."
  (when (string-match "uniquify-files-resources" dir)
    (make-uniquify-test-project :root (locate-dominating-file dir "foo-file3.texts2"))))

(cl-defmethod project-library-roots ((_prj uniquify-test-project))
  nil)

(cl-defmethod project-roots ((prj uniquify-test-project))
  (list (uniquify-test-project-root prj)))

(defcustom uniquify-test-project-completion-style 'default
  "Completion style for uniquify-test `project-file-completion-table';
determines which completion table to return."
  :group 'minibuffer ;; same as other completion options
  :type '(choice
	  (const default) ;; defers to project-file-completion-styles
	  (const file-root-rel)
	  (const uniquify-file))
  )

(cl-defmethod project-file-completion-table ((prj uniquify-test-project) dirs)
  (let ((iter (make-path-iterator
	       :user-path-non-recursive nil
	       :user-path-recursive (or dirs (list (uniquify-test-project-root prj))))))
    (cl-ecase uniquify-test-project-completion-style
      (default
	(path-iter-all-files iter))

      (file-root-rel
       (apply-partially 'fc-root-rel-completion-table-iter iter))

      (uniquify-file
       (apply-partially #'uniq-file-completion-table iter))
    )))

(add-to-list 'project-find-functions #'uniquify-test-project-try)

(provide 'uniquify-test-project)
;; end of file
